using Indotalent.ConfigBackEnd.Exceptions;
using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Inventory.ProductGroup.Cqrs;

public class UpdateProductGroupRequest
{
    public string? Id { get; set; }
    public string? Name { get; set; }
    public string? Description { get; set; }
    public DateTimeOffset? CreatedAt { get; set; }
    public string? CreatedBy { get; set; }
    public DateTimeOffset? UpdatedAt { get; set; }
    public string? UpdatedBy { get; set; }
}

public class UpdateProductGroupResponse
{
    public string? Id { get; set; }
    public bool Success { get; set; }
}

public record UpdateProductGroupCommand(UpdateProductGroupRequest Data) : IRequest<UpdateProductGroupResponse>;

public class UpdateProductGroupHandler : IRequestHandler<UpdateProductGroupCommand, UpdateProductGroupResponse>
{
    private readonly AppDbContext _context;

    public UpdateProductGroupHandler(AppDbContext context) => _context = context;

    public async Task<UpdateProductGroupResponse> Handle(UpdateProductGroupCommand request, CancellationToken cancellationToken)
    {
        var isExists = await _context.ProductGroup
            .AnyAsync(x => x.Name == request.Data.Name && x.Id != request.Data.Id, cancellationToken);

        if (isExists)
        {
            throw new AlreadyExistsException("Product Group", request.Data.Name ?? string.Empty);
        }

        var entity = await _context.ProductGroup
            .FirstOrDefaultAsync(x => x.Id == request.Data.Id, cancellationToken);

        if (entity == null)
        {
            return new UpdateProductGroupResponse { Id = request.Data.Id, Success = false };
        }

        entity.Name = request.Data.Name;
        entity.Description = request.Data.Description;
        await _context.SaveChangesAsync(cancellationToken);

        return new UpdateProductGroupResponse
        {
            Id = entity.Id,
            Success = true
        };
    }
}